import 'dart:convert';

import 'package:ags_authrest2/ags_authrest.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:http/http.dart' as http;

void main() {
  test('fetch data', () async {
    var auth = Ags_restauth();
    auth.SECERT_JWT = 'ihavealongpassword';
    auth.R_USER = 'karantest';
    //  body + headers
    var headers = {
      'path': 'test',
      'port': '5016',
      'Authorization': auth.genTokenEncryp(), // genTokenEncryp() or genToken()
      'Content-Type': 'application/json'
    };
    // ex. body
    var bodyData = {
      "phone": "+66885257777",
      "otpCode": "778747",
      "refCode": "orxh4f",
      "fromBU": "Qsms"
    };
    // ex. fetch data
    var body = json.encode(bodyData);
    var request = http.Request('POST', Uri.parse('http://localhost:3999/'));
    request.body = json
        .encode(auth.encrypbody(body)); //encrypbody require genTokenEncryp()
    request.headers.addAll(headers);
    // print(request.body);
    http.StreamedResponse response = await request.send();

    if (response.statusCode == 200) {
      var dataRaw = await response.stream.bytesToString();
      var data = json.decode(dataRaw);
      var decrypted = auth.decrypbody(
          data); //decrypbody Optional require res.send(encrypbody()) in server
      print(decrypted['phone']);
    } else {
      print(response.reasonPhrase);
    }
  });
}
